//  yuv2nv12.h
//
//	YUV to NV12 converter
//
//	Copyright (c) 2005 N099
//

//GUID
/* 449cb461-f808-4889-b93e-b12be863266d */
DEFINE_GUID(CLSID_YUV2NV12,
	0x449cb461,
    0xf808,
    0x4889,
    0xb9, 0x3e, 0xb1, 0x2b, 0xe8, 0x63, 0x26, 0x6d);


class Cyuv2nv12 : public CTransformFilter
{
private:
	LONG height;      // C[W̍
	LONG width_in;    // ̓C[W̕(XgChȂ)
	LONG width_in_s;  // ̓C[W̕(XgCh)
	LONG width_out;   // o̓C[W̕(XgChȂ)
	LONG width_out_s; // o̓C[W̕(XgCh)
	int format_in;    // ̓tH[}bg
	int interlace;    // C^[[X(t[Ƃ̃tO)
	CONFIG conf;
	CCritSec  m_cs;   // Lf[^ی삷

	//
	HRESULT CheckInterlace(IMediaSample *);
	void Convert(BYTE *, BYTE *, IMediaSample *);
	BITMAPINFOHEADER *GetBmiHeader(const CMediaType &) const;
	void CopySubsetVIF2Flag(VIDEOINFOHEADER2 *, const VIDEOINFOHEADER2 *) const;

public:
	DECLARE_IUNKNOWN;
	Cyuv2nv12(TCHAR *, LPUNKNOWN);
	HRESULT CheckInputType(const CMediaType *);
	HRESULT GetMediaType(int, CMediaType *);
	HRESULT CheckTransform(const CMediaType *, const CMediaType *);
	HRESULT DecideBufferSize(IMemAllocator *, ALLOCATOR_PROPERTIES *);
	HRESULT Transform(IMediaSample *, IMediaSample *);
	HRESULT CompleteConnect(PIN_DIRECTION, IPin *);
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN, HRESULT *);
};

REGPINTYPES sudOutputTypes = { &MEDIATYPE_Video, &MEDIASUBTYPE_NV12 };
REGPINTYPES sudInputTypes[] = {
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_YV12 },
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_YUY2 }
};

// s錾B
REGFILTERPINS sudPinReg[] = {
    // ̓sB
    { 0, FALSE, // Rendered?
         FALSE, // Output?
         FALSE, // Zero?
         FALSE, // Many?
         0, 0, 
         2, sudInputTypes  // Media types.
    },
    // o̓sB
    { 0, FALSE, // _OĂ邩?
         TRUE, // o?
         FALSE, // [?
         FALSE, // ?
         0, 0, 
         1, &sudOutputTypes      // fBA ^CvB
    }
};
 
// tB^錾B
REGFILTER2 rf2FilterReg = {
    1,                // o[WԍB
    MERIT_DO_NOT_USE, // bgB
    2,                // s̐B
    sudPinReg         // sւ̃|C^B
};


//tB^
static WCHAR g_wszName[] = L"YUV to NV12 converter";

CFactoryTemplate g_Templates[] = 
{
  { 
    g_wszName,
    &CLSID_YUV2NV12,
    Cyuv2nv12::CreateInstance,
    NULL,
    NULL
  }
};

int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);
